<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2008 2do | Florian Steigerwald <f.steigerwald@two-do.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');

/* Hilfsfunktionen */
require_once(t3lib_extMgm::extPath('tdo_doptin_download').'res/class/class.tx_tdodooptindownload_helper.php');

/**
 * Plugin 'Download Sign Up' for the 'tdo_doptin_download' extension.
 *
 * @author	2do | Florian Steigerwald <f.steigerwald@two-do.com>
 * @package	TYPO3
 * @subpackage	tx_tdodoptindownload
 */
class tx_tdodoptindownload_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_tdodoptindownload_pi1';		// Same as class name
	var $prefixIdAction= 'tx_tdodoptindownload_pi3';		// Actionplugin
	var $scriptRelPath = 'pi1/class.tx_tdodoptindownload_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'tdo_doptin_download';	// The extension key.
	var $pi_checkCHash = true;
	
	/**
    * Debuggingflag
    * @access protected
    * @var Boolean
    */
	protected $_DEBUG_ = 1;

	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	public function main($content,$conf)
	{
		$this->conf=$conf;
	    
	    /* Init der Extension */
	    $this->init();	
        
//        if ($this->_DEBUG_) $this->_DGSTR_ .= t3lib_div::view_array($this->cObj->data['pi_flexform']);	
//        if ($this->_DEBUG_) $this->_DGSTR_ .= t3lib_div::view_array($this->conf);	

		$content = $this->create_output();
		
	    if ($this->_DEBUG_) $content = $this->_DGSTR_ . $content;
	
		return $this->pi_wrapInBaseClass($content);
	}

	/**
	 * Init Function: here all the needed configuration values are stored in class variables..
	 *
	 * @return	void
	 */
	protected function init() 
	{
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_USER_INT_obj=1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!		
		$this->pi_initPIflexForm(); // Init FlexForm configuration for plugin

	    /* Hilfsklasse instanzieren */
		$this->REF_HLP = t3lib_div::makeInstance('tx_tdodooptindownload_helper');

		/* Text fr Submitbutton */
		$this->submit_text = trim($this->pi_getFFValue($this->cObj->data['pi_flexform'], 'submit_text'));
		
		/* Seite fr die Verarbeitung des Formulars */
		$this->PIDExecute = intval($this->pi_getFFValue($this->cObj->data['pi_flexform'], 'PIDExecute'));

		/* Kampagne */
		$this->campaign = intval($this->pi_getFFValue($this->cObj->data['pi_flexform'], 'campaign'));

		/* Storage_pid */
		$this->storagePID = intval($this->conf['storagePID']);

		/* berschrift */
		$this->header = trim($this->pi_getFFValue($this->cObj->data['pi_flexform'], 'header_rechts'));

		/* Name ist Pflicht */
		$this->name_obligation = $this->pi_getFFValue($this->cObj->data['pi_flexform'], 'name_obligation');


		/* Template einlesen */
		$this->main_tmplate = $this->cObj->fileResource($this->conf['file.']['registrationTemplFile']);
		$this->main_tmplate = $this->cObj->getSubpart($this->main_tmplate, '###DOKUMENT_BODY###');
    }	

	/**
	 * Output Function: Generate the output
	 *
	 * @return	void
	 */
	protected function create_output() 
	{
        if (!empty($this->piVars['sent']))
        {
            $error = array();
//            $link = tslib_pibase::pi_getPageLink($pageid, '', $querarray);            
            if (!$this->REF_HLP->is_email($this->piVars['email']))
            {
                $error[] = 'email';
            }else
            {
                $this->main_tmplate = $this->cObj->substituteSubpart($this->main_tmplate, '###ERR_MAIL###', '');
            }

            if ($this->name_obligation and empty($this->piVars['name']))
            {
                $error[] = 'name';
            }else
            {
                $this->main_tmplate = $this->cObj->substituteSubpart($this->main_tmplate, '###ERR_NAME###', '');
            }

            
            if (empty($error))
            {
                /* indenthash */
                $hash = $this->REF_HLP->uniq_id($this->prefixId);
                
//                print_r($GLOBALS['TSFE']);
                print_r($this->cObj->paren);
                /* in DB speichern */
                $fields_values = array('hash' => $hash,
                                       'surname' => $this->piVars['name'],
                                       'pid' => $this->storagePID,
                                       'campaign' => $this->campaign,
                                       'email' => $this->piVars['email']);
                $resIns = $GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_tdodoptindownload_temp_user',$fields_values);
                
                $qa = array($this->prefixIdAction => array('hash' => $hash));
                
                $this->REF_HLP->my_header($this->PIDExecute, $qa);    
            }
        }else
        {
            $this->main_tmplate = $this->cObj->substituteSubpart($this->main_tmplate, '###ERR_MAIL###', '');
            $this->main_tmplate = $this->cObj->substituteSubpart($this->main_tmplate, '###ERR_NAME###', '');
        }
        
        /* berschrift */
        if (empty($this->header))
        {
    		$this->main_tmplate = $this->cObj->substituteSubpart($this->main_tmplate, '###HEADER###', '');
        }else{
            $markerArray['###TXT###'] = htmlentities($this->header, ENT_COMPAT, 'UTF-8');
        }

	    $markerArray['###NAME###'] = $this->piVars['name'];
	    $markerArray['###EMAIL###'] = $this->piVars['email'];
	    
	    $markerArray['###BTN_VALUE###'] = htmlentities($this->submit_text, ENT_COMPAT, 'UTF-8');
	    $markerArray['###PAGEID###'] = $GLOBALS['TSFE']->id;
	    $markerArray['###PREFIX###'] = $this->prefixId;
	    
		return $this->cObj->substituteMarkerArray($this->main_tmplate, $markerArray);
    }	    
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tdo_doptin_download/pi1/class.tx_tdodoptindownload_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tdo_doptin_download/pi1/class.tx_tdodoptindownload_pi1.php']);
}

?>