<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2008 2do | Florian Steigerwald <f.steigerwald@two-do.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');

require_once(t3lib_extMgm::extPath('tdo_doptin_download').'res/class/class.tx_tdodooptindownload_helper.php');
/**
 * Plugin 'File Download' for the 'tdo_doptin_download' extension.
 *
 * @author	2do | Florian Steigerwald <f.steigerwald@two-do.com>
 * @package	TYPO3
 * @subpackage	tx_tdodoptindownload
 */
class tx_tdodoptindownload_pi2 extends tslib_pibase {
	var $prefixId      = 'tx_tdodoptindownload_pi2';		// Same as class name
	var $scriptRelPath = 'pi2/class.tx_tdodoptindownload_pi2.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'tdo_doptin_download';	// The extension key.

	/**
    * Debuggingflag
    * @access protected
    * @var Boolean
    */
	protected $_DEBUG_ = 1;

	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content,$conf)	{
		$this->conf=$conf;

	    /* Init der Extension */
	    $this->init();

//        if ($this->_DEBUG_) $this->_DGSTR_ .= t3lib_div::view_array($this->cObj->data['pi_flexform']);
//        if ($this->_DEBUG_) $this->_DGSTR_ .= t3lib_div::view_array($this->conf);

		switch ($_REQUEST['ac'])
		{
	    case 'oi':
            $this->piVars['hash'] = $_REQUEST['hs'];
	        $content = $this->create_output_optin();
		    break;
	    case 'bl':
//	        echo 'bl';
	        $this->piVars['hash'] = $_REQUEST['hs'];
	        $content = $this->create_output_blacklist();
		    break;
        default:

		}


	    if ($this->_DEBUG_) $content = $this->_DGSTR_ . $content;

		return $this->pi_wrapInBaseClass($content);
	}

	/**
	 * Init Function: here all the needed configuration values are stored in class variables..
	 *
	 * @return	void
	 */
	protected function init()
	{
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_USER_INT_obj=1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
		$this->pi_initPIflexForm(); // Init FlexForm configuration for plugin

	    /* Hilfsklasse instanzieren */
		$this->REF_HLP = t3lib_div::makeInstance('tx_tdodooptindownload_helper');

		/* Download Datei */
		$this->dl_file = sprintf('fileadmin/register_download/%s', trim($this->pi_getFFValue($this->cObj->data['pi_flexform'], 'dl_file', 'sDEF')));

		/* Download Datei */
		$this->dl_filename = trim($this->pi_getFFValue($this->cObj->data['pi_flexform'], 'dl_filename', 'sDEF'));

		/* lifetime */
		$this->lifetime = intval($this->pi_getFFValue($this->cObj->data['pi_flexform'], 'lifetime', 'sDEF'));

		/* Userdatennderung anzeigen */
		$this->show_change_form = $this->pi_getFFValue($this->cObj->data['pi_flexform'], 'show_change_form', 'sDEF');

		/* Grund Textarea */
		$this->show_grund_textarea = $this->pi_getFFValue($this->cObj->data['pi_flexform'], 'show_grund_textarea', 's_blacklist');

		/* Titel Downloadseite */
		$this->confirmation_header = $this->pi_getFFValue($this->cObj->data['pi_flexform'], 'confirmation_header', 's_confirmation');

		/* Text Downloadseite */
		$this->confirmation_message = $this->pi_getFFValue($this->cObj->data['pi_flexform'], 'confirmation_message', 's_confirmation');

		/* Titel Optin Fehler */
		$this->error_header = $this->pi_getFFValue($this->cObj->data['pi_flexform'], 'error_header', 's_error');

		/* Nachricht Optin Fehler */
		$this->error_message = $this->pi_getFFValue($this->cObj->data['pi_flexform'], 'error_message', 's_error');

		/* Titel Abgelaufen */
		$this->expired_header = $this->pi_getFFValue($this->cObj->data['pi_flexform'], 'expired_header', 's_expired');

		/* Nachricht Abgelaufen */
		$this->expired_message = $this->pi_getFFValue($this->cObj->data['pi_flexform'], 'expired_message', 's_expired');

		/* Titel Blacklist */
		$this->blacklist_header = $this->pi_getFFValue($this->cObj->data['pi_flexform'], 'blacklist_header', 's_blacklist');

		/* Text Blacklist */
		$this->blacklist_message = $this->pi_getFFValue($this->cObj->data['pi_flexform'], 'blacklist_message', 's_blacklist');

		/* Titel Blacklisted */
		$this->blacklisted_header = $this->pi_getFFValue($this->cObj->data['pi_flexform'], 'blacklisted_header', 's_blacklisted');

		/* Text Blacklist */
		$this->blacklisted_message = $this->pi_getFFValue($this->cObj->data['pi_flexform'], 'blacklisted_message', 's_blacklisted');


		/* Template einlesen */
		$this->all_tmplate = $this->cObj->fileResource($this->conf['file.']['mainTemplFile']);
		$this->main_tmplate = $this->cObj->getSubpart($this->all_tmplate, '###DOKUMENT_BODY###');

		/* Template einlesen */
		$this->bl_tmplate = $this->cObj->fileResource($this->conf['file.']['blacklistTemplFile']);
		$this->main_tmplate = $this->cObj->getSubpart($this->all_tmplate, '###DOKUMENT_BODY###');

    }

	/**
	 * Output Function: Generate the output
	 *
	 * @return	void
	 */
	protected function create_output_optin()
{
	    try
	    {
    	    /* Userdaten mit Hash */
    	    $userData = $GLOBALS['TYPO3_DB']->exec_SELECTquery('DISTINCT du.*, tu.campaign as campaignid',
    	                                                       'tx_tdodoptindownload_temp_user tu, tx_tdodoptindownload_download_user du',
    	                                                       sprintf('tu.email = du.email AND hash = %s', $GLOBALS['TYPO3_DB']->fullQuoteStr($this->piVars['hash'], 'tx_tdodoptindownload_temp_user')),
    	                                                       1);
            if($userData)
            {
                $userData= $GLOBALS['TYPO3_DB']->sql_fetch_assoc($userData);
            }
//            var_dump($userData);

            /* Keine Daten gefunden */
            if (empty($userData))
            {
                throw new Exception('nodata');
            }

            /* Download abgelaufen prfen nur wenn ntig */
            if ($this->lifetime > 0)
            {
                /* Prfen ob Erster Download nicht zu lange her */
                $query = <<<SQL
SELECT DATE_ADD(NOW(), INTERVAL -%d HOUR) < ifNULL((SELECT `tstamp`
FROM `tx_tdodoptindownload_download_log`
WHERE `uid` = %d
AND `pid` = %d
AND `campaignid` = %d ORDER BY `tstamp` ASC LIMIT 1), NOW());
SQL;

                $query = sprintf($query, $this->lifetime, $userData['uid'], $userData['pid'], $userData['campaignid']);
//                echo $query;
        	    $dlLogData = $GLOBALS['TYPO3_DB']->sql_query($query);

                /* Wenn Daten da, dann Prfung ob innerhalb der Zeit */
                if($dlLogData)
                {
                    $dlLogData= $GLOBALS['TYPO3_DB']->sql_fetch_row($dlLogData);
//                    var_dump($dlLogData);
                    if ($dlLogData[0] != 1)
                    {
                        throw new Exception('expired');
                    }
                }
            }


    	    /* Daten nderungsform */
    	    $chfTmpl = '';
    	    if ($this->show_change_form)
    	    {
    	        $chfTmpl = $this->cObj->getSubpart($this->all_tmplate, '###CHANGEFORM###');

                /* Init der Werte aus DB */
                if (empty($this->piVars['chd']))
                {
                    $this->piVars['fd']['anrede'] = $userData['address'];
                    $this->piVars['fd']['titel'] = $userData['title'];
            	    $this->piVars['fd']['vorname'] = $userData['firstname'];
            	    $this->piVars['fd']['name'] = $userData['surname'];

                    /* Fehler erstmal weg */
                    $chfTmpl = $this->cObj->substituteSubpart($chfTmpl, '###ERR_MAIL###', '');
                    $chfTmpl = $this->cObj->substituteSubpart($chfTmpl, '###ERR_NAME###', '');
                }

                /* Form abgesendet */
                if (empty($this->piVars['saveok']))
                {
                     $chfTmpl = $this->cObj->substituteSubpart($chfTmpl, '###SAVEOK###', '');
                }

                /* Dateiladen */
                if (!empty($this->piVars['dl']))
                {
                    /* Download loggen */
                    $fields_values = array('uid' => sprintf('%d', $userData['uid']),
                                           'pid' => sprintf('%d', $userData['pid']),
                                           'campaignid' => sprintf('%d', $userData['campaignid']),
                                           'filename' => basename($this->dl_file),
                                           );
                    $resIns = $GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_tdodoptindownload_download_log',
                                                                     $fields_values);
                    $this->REF_HLP->my_download($this->dl_file);
                }

                /* Form abgesendet */
                if (!empty($this->piVars['chd']))
                {
//                    $error = array();
//                    if (!$this->REF_HLP->is_email($this->piVars['fd']['email']))
//                    {
//                        $error[] = 'email';
//                    }else
//                    {
//                        $chfTmpl = $this->cObj->substituteSubpart($chfTmpl, '###ERR_MAIL###', '');
//                    }

                    if (empty($this->piVars['fd']['name']))
                    {
                        $error[] = 'name';
                    }else
                    {
                        $chfTmpl = $this->cObj->substituteSubpart($chfTmpl, '###ERR_NAME###', '');
                    }


                    /* Keine Fehler, dann Daten aktualisieren */
                    if (1 and empty($error))
                    {
                        /* in DB updaten */
                        $fields_values = array('surname' => $this->piVars['fd']['name'],
                                               'address' => $this->piVars['fd']['anrede'],
                                               'firstname' => $this->piVars['fd']['vorname'],
                                               'title' => $this->piVars['fd']['titel']
                                               );
                        $resIns = $GLOBALS['TYPO3_DB']->exec_UPDATEquery('tx_tdodoptindownload_download_user',
                                                                         sprintf('uid = %d', $userData['uid']),
                                                                         $fields_values);
//                        var_dump($resIns);
                        $qa = array('ac' => $_REQUEST['ac'],
                                    'hs' => $_REQUEST['hs'],
                                    $this->prefixId => array('saveok' => 1));

                        $this->REF_HLP->my_header($GLOBALS['TSFE']->id, $qa);
                    }
                }

        	    $markerArrayChf['###FD_TITLE###'] = $this->piVars['fd']['titel'];
        	    $markerArrayChf['###FD_VORNAME###'] = $this->piVars['fd']['vorname'];
        	    $markerArrayChf['###FD_NAME###'] = $this->piVars['fd']['name'];
        	    $markerArrayChf['###FD_EMAIL###'] = $this->piVars['fd']['email'];

                /* Anrede Optionen */
                $anredeOptions = $this->REF_HLP->render_select('n_array', $this->piVars['fd']['anrede'],'','',array('Herr', 'Frau'));
                $chfTmpl = $this->cObj->substituteSubpart($chfTmpl, '###ANREDEOPTIONS###', $anredeOptions);

                $chfTmpl = $this->cObj->substituteMarkerArray($chfTmpl, $markerArrayChf);
    	    }

            $titel = $this->confirmation_header;
            $body = $this->confirmation_message;
    		$tmpl = $this->cObj->getSubpart($this->all_tmplate, '###DL###');


    	    /* nderungsform */
    	    $markerArrayPre['###CHANGEFORM###'] = $chfTmpl;

            $body = $this->cObj->substituteMarkerArray($body, $markerArrayPre);

        } catch (Exception $e) {
            switch ($e->getMessage())
            {
            case 'nodata':
                $titel = $this->error_header;
                $body = $this->error_message;
        		$tmpl = $this->cObj->getSubpart($this->all_tmplate, '###OPTINERRR###');

                break;
            case 'expired':
                $titel = $this->expired_header;
                $body = $this->expired_message;
        		$tmpl = $this->cObj->getSubpart($this->all_tmplate, '###EXPIREDERR###');
                break;
            }
        }

        /* Titel */
	    $markerArray['###TXT###'] = $this->cObj->stdWrap(htmlentities($titel, ENT_COMPAT, 'UTF-8'), $this->conf['header_stdWrap.']);

        /* Body */
	    $markerArray['###BODY###'] = $body;

		$tmpl = $this->cObj->substituteMarkerArray($tmpl, $markerArray);

		return $this->all_substituts($tmpl, $userData);
    }


	/**
	 * Output Function: Generate the output
	 *
	 * @return	void
	 */
	protected function create_output_blacklist()
	{
	    try
	    {
    	    /* Userdaten mit Hash */
    	    $userData = $GLOBALS['TYPO3_DB']->exec_SELECTquery('DISTINCT du.*, tu.campaign as campaignid',
    	                                                       'tx_tdodoptindownload_temp_user tu, tx_tdodoptindownload_download_user du',
    	                                                       sprintf('tu.email = du.email AND hash = %s', $GLOBALS['TYPO3_DB']->fullQuoteStr($this->piVars['hash'], 'tx_tdodoptindownload_temp_user')),
    	                                                       1);
            if($userData)
            {
                $userData= $GLOBALS['TYPO3_DB']->sql_fetch_assoc($userData);
            }
//            var_dump($userData);

            /* Keine Daten gefunden */
            if (empty($userData))
            {
                throw new Exception('alreadyblacklisted');
            }

            /* Bereits auf der Blacklist ? */

    	    $onBL = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
	                                                       '`tx_tdodoptindownload_download_user`',
	                                                       sprintf('`uid` = %d AND `pid` = %d AND `blacklist` = %d', $userData['uid'],
	                                                                                                                 $userData['pid'],
	                                                                                                                 1),
	                                                       1);
            if(!empty($this->piVars['blok']))
            {
                throw new Exception('blacklistedok');
            }

            if($onBL)
            {
                $onBL= $GLOBALS['TYPO3_DB']->sql_fetch_assoc($onBL);
                if ($onBL['blacklist'] == 1)
                {
                    throw new Exception('alreadyblacklisted');
                }
            }

    	    /* Daten nderungsform */
    	    $grundTmpl = '';
    	    if ($this->show_grund_textarea)
    	    {
    	        $grundTmpl = $this->cObj->getSubpart($this->bl_tmplate, '###GRUNDTA###');

                /* Form abgesendet */
                if (!empty($this->piVars['dobl']))
                {
                    /* Download loggen */
                    $fields_values = array('uid' => sprintf('%d', $userData['uid']),
                                           'pid' => sprintf('%d', $userData['pid']),
                                           'email' => $userData['email'],
                                           'grund' => $this->piVars['fd']['grund']
                                           );
                    $resIns = $GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_tdodoptindownload_blacklist',
                                                                     $fields_values
                                                                     );

                    /* in DB updaten */
                    $fields_values = array('blacklist' => 1);
                    $resIns = $GLOBALS['TYPO3_DB']->exec_UPDATEquery('tx_tdodoptindownload_download_user',
                                                                     sprintf('uid = %d', $userData['uid']),
                                                                     $fields_values);
//                        var_dump($resIns);
                    $qa = array('ac' => $_REQUEST['ac'],
                                'hs' => $_REQUEST['hs'],
                                $this->prefixId => array('blok' => 1));

                    $this->REF_HLP->my_header($GLOBALS['TSFE']->id, $qa);
                }

        	    $markerArrayChf['###GRUNDTXT###'] = $this->piVars['fd']['grund'];

                $grundTmpl = $this->cObj->substituteMarkerArray($grundTmpl, $markerArrayChf);
    	    }


            $titel = $this->blacklist_header;
            $body = $this->blacklist_message;
    		$tmpl = $this->cObj->getSubpart($this->bl_tmplate, '###MSG###');


    	    /* Grund */
    	    $markerArrayPre['###GRUND###'] = $grundTmpl;

            $body = $this->cObj->substituteMarkerArray($body, $markerArrayPre);

        } catch (Exception $e) {
            switch ($e->getMessage())
            {
            case 'alreadyblacklisted':
                $titel = $this->blacklisted_header;
                $body = $this->blacklisted_message;
        		$tmpl = $this->cObj->getSubpart($this->all_tmplate, '###BLERR###');
                break;
            case 'blacklistedok':
                $titel = $this->blacklist_header;
        		$tmpl = $this->cObj->getSubpart($this->bl_tmplate, '###MSGOK###');
                break;
            }
        }

        /* Titel */
	    $markerArray['###TXT###'] = $this->cObj->stdWrap(htmlentities($titel, ENT_COMPAT, 'UTF-8'), $this->conf['header_stdWrap.']);

        /* Body */
	    $markerArray['###BODY###'] = $body;

		$tmpl = $this->cObj->substituteMarkerArray($tmpl, $markerArray);

		return $this->all_substituts($tmpl, $userData);
    }

	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$body: Nachricht
	 * @param	array		$userdata: Userdaten
	 * @param	bool        $ishtml: HTML Body
	 * @return	text
	 */
	protected function all_substituts($body, $userdata)
	{
	    $markerArray['###PAGEID###'] = $GLOBALS['TSFE']->id;
	    $markerArray['###PREFIX###'] = $this->prefixId;
	    $markerArray['###AC###'] = $_REQUEST['ac'];
	    $markerArray['###HASH###'] = $_REQUEST['hs'];

        $qa = array('ac' => $_REQUEST['ac'],
                    'hs' => $_REQUEST['hs'],
                    $this->prefixId => array('dl' => 1));

        $filename = htmlentities(!empty($this->dl_filename) ? $this->dl_filename : basename($this->dl_file), ENT_COMPAT, 'UTF-8');

        $DLFILE = $this->pi_linkToPage($filename, $GLOBALS['TSFE']->id, '_blank', $qa);
        $markerArray['###DLFILE###'] = $this->cObj->stdWrap($DLFILE, $this->conf['dllink_stdWrap.']);


	    $markerArray['###NAME###'] = htmlentities($userdata['surname'], ENT_COMPAT, 'UTF-8');
	    $markerArray['###EMAIL###'] = htmlentities($userdata['email'], ENT_COMPAT, 'UTF-8');

	    $markerArray['###FIRSTNAME###'] = htmlentities($userdata['firstname'], ENT_COMPAT, 'UTF-8');
	    $markerArray['###SURNAME###'] = htmlentities($userdata['surname'], ENT_COMPAT, 'UTF-8');
	    $markerArray['###ADDRESS###'] = htmlentities($userdata['address'], ENT_COMPAT, 'UTF-8');
	    $markerArray['###TITLE###'] = htmlentities($userdata['title'], ENT_COMPAT, 'UTF-8');

        $fullname = array();
        if(!empty($userdata['title']))      $fullname[] = $userdata['title'];
        if(!empty($userdata['firstname']))  $fullname[] = $userdata['firstname'];
        if(!empty($userdata['surname']))    $fullname[] = $userdata['surname'];

	    $markerArray['###FULLNAME###'] = htmlentities(implode(' ', $fullname), ENT_COMPAT, 'UTF-8');

		return $this->cObj->substituteMarkerArray($body, $markerArray);
	}

}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tdo_doptin_download/pi2/class.tx_tdodoptindownload_pi2.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tdo_doptin_download/pi2/class.tx_tdodoptindownload_pi2.php']);
}

?>