<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2008 2do | Florian Steigerwald <f.steigerwald@two-do.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');

require_once(t3lib_extMgm::extPath('tdo_doptin_download').'res/class/class.tx_tdodooptindownload_helper.php');
/**
 * Plugin 'Sign Up confirmation + email' for the 'tdo_doptin_download' extension.
 *
 * @author	2do | Florian Steigerwald <f.steigerwald@two-do.com>
 * @package	TYPO3
 * @subpackage	tx_tdodoptindownload
 */
class tx_tdodoptindownload_pi3 extends tslib_pibase {
	var $prefixId      = 'tx_tdodoptindownload_pi3';		// Same as class name
	var $scriptRelPath = 'pi3/class.tx_tdodoptindownload_pi3.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'tdo_doptin_download';	// The extension key.
	
	/**
    * Debuggingflag
    * @access protected
    * @var Boolean
    */
	protected $_DEBUG_ = 1;

	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content,$conf)	{
		$this->conf=$conf;
	    
	    /* Init der Extension */
	    $this->init();	
        
//        if ($this->_DEBUG_) $this->_DGSTR_ .= t3lib_div::view_array($this->cObj->data['pi_flexform']);	
//        if ($this->_DEBUG_) $this->_DGSTR_ .= t3lib_div::view_array($this->conf);	

		$content = $this->create_output();
		
	    if ($this->_DEBUG_) $content = $this->_DGSTR_ . $content;
	
		return $this->pi_wrapInBaseClass($content);
	}

	/**
	 * Init Function: here all the needed configuration values are stored in class variables..
	 *
	 * @return	void
	 */
	protected function init() 
	{
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_USER_INT_obj=1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
		$this->pi_initPIflexForm(); // Init FlexForm configuration for plugin

	    /* Hilfsklasse instanzieren */
		$this->REF_HLP = t3lib_div::makeInstance('tx_tdodooptindownload_helper');

		/* Seite fr die Verarbeitung des E-Mail Links */
		$this->PIDOptin = intval($this->pi_getFFValue($this->cObj->data['pi_flexform'], 'PIDOptin'));

		/* berschrift */
		$this->header = trim($this->pi_getFFValue($this->cObj->data['pi_flexform'], 'header'));

		/* Body */
		$this->body = trim($this->pi_getFFValue($this->cObj->data['pi_flexform'], 'message'));

		/* Email: Name des Senders */
		$this->email['sendername'] = trim($this->pi_getFFValue($this->cObj->data['pi_flexform'], 'sendername'));

		/* Email: E-Mail des Senders */
		$this->email['senderemail'] = trim($this->pi_getFFValue($this->cObj->data['pi_flexform'], 'senderemail'));

		/* Email: Betreff */
		$this->email['subject'] = trim($this->pi_getFFValue($this->cObj->data['pi_flexform'], 'subject'));

		/* Email: HTML */
		$this->email['htmlemail'] = trim($this->pi_getFFValue($this->cObj->data['pi_flexform'], 'htmlemail'));

		/* Email: TEXT */
		$this->email['textemail'] = trim($this->pi_getFFValue($this->cObj->data['pi_flexform'], 'textemail'));

		/* Email: Prioritt */
		$this->email['priority'] = intval($this->pi_getFFValue($this->cObj->data['pi_flexform'], 'priority'));

		/* Template einlesen */
		$this->all_tmplate = $this->cObj->fileResource($this->conf['file.']['confirmationTemplFile']);
		$this->main_tmplate = $this->cObj->getSubpart($this->all_tmplate, '###DOKUMENT_BODY###');

		/* HTML Template einlesen */
		$this->html_tmplate = $this->cObj->fileResource($this->conf['file.']['mailTemplFile']);
		$this->html_tmplate = $this->cObj->getSubpart($this->html_tmplate, '###DOKUMENT_BODY###');
    }	

	/**
	 * Output Function: Generate the output
	 *
	 * @return	void
	 */
	protected function create_output() 
	{
	    /* Userdaten mit Hash */
	    $userData = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*', 
	                                                       'tx_tdodoptindownload_temp_user', 
	                                                       sprintf('hash = %s', $GLOBALS['TYPO3_DB']->fullQuoteStr($this->piVars['hash'], 'tx_tdodoptindownload_temp_user')),
	                                                       1);
        if($userData)
        {
            $userData= $GLOBALS['TYPO3_DB']->sql_fetch_assoc($userData);
        }
//        var_dump($userData);
	    
	    /* Ohne Hash nichts los */
        if (empty($this->piVars['hash']) or empty($userData['email']))
        {
            $this->REF_HLP->my_header($this->conf['homePID']);
        }

	    $existingUserData = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*', 
	                                                       'tx_tdodoptindownload_download_user', 
	                                                       sprintf('email = %s', $GLOBALS['TYPO3_DB']->fullQuoteStr($userData['email'], 'tx_tdodoptindownload_download_user')),
	                                                       1);
//        var_dump($existingUserData);
        /* uid des Users ermitteln */
        /* ist user schon vorhanden */
        if($existingUserData and $GLOBALS['TYPO3_DB']->sql_num_rows($existingUserData))
        {
            $existingUserData = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($existingUserData);
//            var_dump($existingUserData);
            $lastID = $existingUserData['uid'];
        }else
        {
            /* Speichern der Daten des Users */
            $query = sprintf('INSERT INTO `tx_tdodoptindownload_download_user` (`pid`, `tstamp`, `crdate`, `address`, `title`, `firstname`, `surname`, `email`,`campaign`) '.
                             'VALUES (%d, UNIX_TIMESTAMP(), UNIX_TIMESTAMP(), %s, %s, %s, %s, %s, %d);',
                             $userData['pid'],
                             $GLOBALS['TYPO3_DB']->fullQuoteStr($userData['address'], 'tx_tdodoptindownload_download_user'),
                             $GLOBALS['TYPO3_DB']->fullQuoteStr($userData['title'], 'tx_tdodoptindownload_download_user'),
                             $GLOBALS['TYPO3_DB']->fullQuoteStr($userData['firstname'], 'tx_tdodoptindownload_download_user'),
                             $GLOBALS['TYPO3_DB']->fullQuoteStr($userData['surname'], 'tx_tdodoptindownload_download_user'),
                             $GLOBALS['TYPO3_DB']->fullQuoteStr($userData['email'], 'tx_tdodoptindownload_download_user'),
                             $userData['campaign']
                             );
//            echo $query;
            $resIns = $GLOBALS['TYPO3_DB']->sql_query($query);
            
            $lastID = $GLOBALS['TYPO3_DB']->sql_insert_id();
        }
//        var_dump($lastID);
        
        /* ist auf Blacklist */
        if (!empty($existingUserData['blacklist']))
        {
            $this->body = $this->cObj->getSubpart($this->all_tmplate, '###BLACKLIST###');
        }else
        /* Nichts gefunden => schlecht! */
        if (empty($lastID))
        {
            $this->body = 'Die Anmeldung hat nicht geklappt! Bitte versuchen Sie es nochmals.';
        }else
        {
            /* Einfgen in MM Relation Kampagne User*/      
            $query = sprintf('INSERT INTO `tx_tdodoptindownload_download_user_campaign_mm` (`uid_local`,`uid_foreign`,`sorting`) '.
                             'VALUES (%d, %d, %d);',
                             $lastID,
                             $userData['campaign'],
                             $userData['campaign']
                             );
    //            echo $query;
            $resIns = $GLOBALS['TYPO3_DB']->sql_query($query);
            
            /* Versenden der Nachricht */
//            var_dump($resIns);
            if ($resIns)
            {
                $recipname = array();
                if(!empty($userData['title'])) $recipname[] = $userData['title'];
                if(!empty($userData['firstname'])) $recipname[] = $userData['firstname'];
                if(!empty($userData['surname'])) $recipname[] = $userData['surname'];
                
                $this->html_tmplate = $this->cObj->substituteMarker($this->html_tmplate, '###MSG###', $this->email['htmlemail']);
                
                $resSend = $this->REF_HLP->send_mail($this->mail_substituts($this->html_tmplate, $userData, 1), 
                                                     $this->mail_substituts($this->email['textemail'], $userData), 
                                                     utf8_decode($this->email['subject']), 
                                                     utf8_decode($this->email['sendername']), 
                                                     utf8_decode($this->email['senderemail']), 
                                                     utf8_decode(implode(' ', $recipname)), 
                                                     $userData['email'],
                                                     $this->email['priority']);
            }else
            {
                $this->body = $this->cObj->getSubpart($this->all_tmplate, '###SCHONANGEMELDET###');
            }
        }

        /* berschrift */
        if (empty($this->header))
        {
            $header = '';    
        }else
        {
            $header = $this->cObj->stdWrap(htmlentities($this->header, ENT_COMPAT, 'UTF-8'), $this->conf['header_stdWrap.']);
        }            
        $this->main_tmplate = $this->cObj->substituteSubpart($this->main_tmplate, '###HEADER###', $header);

        /* Body */
	    $markerArray['###BODY###'] = $this->body;
	    
	    $markerArray['###PAGEID###'] = $GLOBALS['TSFE']->id;
	    $markerArray['###PREFIX###'] = $this->prefixId;
	    
		return $this->cObj->substituteMarkerArray($this->main_tmplate, $markerArray);
    }

	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$body: Nachricht
	 * @param	array		$userdata: Userdaten
	 * @param	bool        $ishtml: HTML Body
	 * @return	text
	 */
	protected function mail_substituts($body, $userdata, $ishtml=0)	
	{
	    $url = parse_url($_SERVER['SCRIPT_URI']);

        $optin = sprintf('%s://%s%s?id=%d&ac=oi&hs=%s', $url['scheme'], $url['host'], $url['path'], $this->PIDOptin, $userdata['hash']);
        $blacklist = sprintf('%s://%s%s?id=%d&ac=bl&hs=%s', $url['scheme'], $url['host'], $url['path'], $this->PIDOptin, $userdata['hash']);

        if ($ishtml)
        {
            $optin = sprintf('<a href="%s">%s</a>', $optin, $optin);
            $blacklist = sprintf('<a href="%s">%s</a>', $blacklist, $blacklist);
        }

	    $markerArray['###OPTIN###'] = $optin;
	    $markerArray['###BLACKLIST###'] = $blacklist;
	    
	    $markerArray['###NAME###'] = $userdata['surname'];
	    $markerArray['###EMAIL###'] = $userdata['email'];

//	    $markerArray['###FIRSTNAME###'] = $userdata['firstname'];
//	    $markerArray['###SURNAME###'] = $userdata['surname'];
//	    $markerArray['###ADDRESS###'] = $userdata['address'];
//	    $markerArray['###TITLE###'] = $userdata['title'];
//
//        $fullname = array();	    
//        if(!empty($userdata['title']))      $fullname[] = $userdata['title'];
//        if(!empty($userdata['firstname']))  $fullname[] = $userdata['firstname'];
//        if(!empty($userdata['surname']))    $fullname[] = $userdata['surname'];
//	    
//	    $markerArray['###FULLNAME###'] = implode(' ', $fullname);
	    
		return utf8_decode($this->cObj->substituteMarkerArray($body, $markerArray));
	}
    
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tdo_doptin_download/pi3/class.tx_tdodoptindownload_pi3.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tdo_doptin_download/pi3/class.tx_tdodoptindownload_pi3.php']);
}

?>