<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2008 2do | Florian Steigerwald <f.steigerwald@two-do.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');


/**
 * Hilfsfunktionen
 *
 * @author	2do | Florian Steigerwald <f.steigerwald@two-do.com>
 * @package	TYPO3
 * @subpackage	tx_tdodoptindownload
 */
class tx_tdodooptindownload_helper extends tslib_pibase {

   /**
    * Konstruktor
    * @return void
    * @access public
    */
	public function __construct() 
	{
		// instanzKlasse fr Markeroperatioen etc
        $this->cObj = new tslib_cObj();
   	}

	/**
	 * Ist richtiges Email-Format
     * @param string Email
	 * @access public
	 * @return bool
	 */
    public function is_email($email)
    {
        $pattern='/^[a-z0-9._-]+@[a-z0-9.-]+\.[a-z]{2,4}$/i';
        if(!preg_match($pattern,$email)){
            return false;
        }
        if (strlen($email)>255){
            return false;
        }
        return true;
    }

	/**
	 * Fhrt Headerbefehl und exit aus<br />
     * @param int id aktuellen Mitglieds
     * @param int id des Betroffenen
	 * @access public
	 * @return string
	 */
	public function my_header($pageid, $querarray=array(), $addSessionIfExists=1)
	{
		if (!is_array($querarray))
		{
			$querarray = array();
		}
		/* FST 28.02.2008 15:08:11 Abfragen ob Session vorhanden ist */
		$sessionID = session_id();
		$sessionName = session_name();
		if (!empty($sessionName) and !empty($sessionID) and $addSessionIfExists)
		{
		    if (is_array($querarray))	
		    {
                $querarray = array_merge($querarray, array($sessionName => $sessionID));
            }
		}

		$link = tslib_pibase::pi_getPageLink($pageid, '', $querarray);
		header("Location: $link");
		exit;
	}

   	/** 
   	 * Gibt eine eindeutige ID<br />
   	 * @param string Prfix
   	 * @access public
   	 * @return uniqid
     */ 
   	public function uniq_id($prefix)
   	{ 
		return md5 ($prefix . uniqid (rand()));
	}

   	/** 
   	 * E-Mail versenden<br />
   	 * @access public
   	 * @return bool
     */ 
   	public function send_mail($htmlbody, $altbody, $subject, $sendername, $senderemail, $recipname, $recipmail, $prio=3)
   	{ 
        require_once(t3lib_extMgm::extPath('tdo_doptin_download').'res/PHPMailer_v2.0.0/class.phpmailer.php');

        $mail    = new PHPMailer();

        $body    = eregi_replace("[\]", '', $htmlbody);

        $mail->From     = $senderemail;
        $mail->FromName = $sendername;

        $mail->Subject  = $subject;

        $mail->AltBody  = $altbody;

        $mail->MsgHTML($body);

        $mail->AddAddress($recipmail, empty($recipname)? $recipmail : $recipname);
        
        $mail->Priority = $prio;
        
        return $mail->Send();
    }

	/**
	 * Optiontags fr SElectboxen erzeugen
     * @param string Typ der Optionerstellung
	 * @param mixed var Array oder Wert fr die aktive Option
	 * @param int Startwert NumOptions
	 * @param int Endwert NumOptions
	 * @param array Werte fr Options
	 * @param string Schlsselname fr Arraykeys
	 * @param string Schlsselname fr Arraywerte
	 * @access public
	 * @return string alle Optionen
	 */
	public function render_select($type,$aktiv=null,$von=0,$bis=20,$values=array(),$keyname='',$valname='', $encrypt=false)
	{
		$result = '';
		switch ($type){
		case 'num':
				for($i=$von;$i<=$bis;$i++){
					$sel = (!strcasecmp($i, $aktiv))?' selected="selected"':'';
					$result .= sprintf("<option value=\"%s\"%s>%s</option>\n",$i,$sel,$i);
				}
			break;
		case 'num_f_0': // Fhrende Nullen werden angehngt
				for($i=$von;$i<=$bis;$i++){
					$sel = (!strcasecmp($i, $aktiv))?' selected="selected"':'';
					if ($i <10) {
						$sel = (!strcasecmp("0$i", $aktiv))?' selected="selected"':'';
						$result .= sprintf("<option value=\"0%s\"%s>0%s</option>\n",$i,$sel,$i);
					} else {
						$sel = (!strcasecmp($i, $aktiv))?' selected="selected"':'';
						$result .= sprintf("<option value=\"%s\"%s>%s</option>\n",$i,$sel,$i);
					}
				}
			break;
		case 'time':
				for($i=$von;$i<=$bis;$i++){
					$sel = ("$i:00:00" == $aktiv)?' selected="selected"':'';
					$result .= sprintf("<option value=\"%s:00:00\"%s>%s:00</option>\n",$i,$sel,$i);
				}
			break;
		case 'timelzero':
				for($i=$von;$i<=$bis;$i++){
					$sel = (sprintf('%02d:00:00', $i) == $aktiv)?' selected="selected"':'';
					$result .= sprintf("<option value=\"%02d:00:00\"%s>%02d:00</option>\n",$i,$sel,$i);
				}
			break;
		case '1k_1v_array':	/* keynames sind die Angezeigten Texte, $valname fr die Options,  */
				for($i=0;$i<sizeof($valname);$i++)
				{
					$sel = (!strcasecmp($valname[$i], $aktiv))?' selected="selected"':'';
					$tmp = ($encrypt)? $this->encrypt($valname[$i]) : $valname[$i];
					$result .= sprintf("<option value=\"%s\"%s>%s</option>\n", $tmp, $sel, $keyname[$i]);
				}
			break;
		case 'n_array':
		case 'narray':
				for($i=0;$i<sizeof($values);$i++){
					$sel = (!strcasecmp($values[$i], $aktiv))?' selected="selected"':'';
					$result .= sprintf("<option value=\"%s\"%s>%s</option>\n",$values[$i],$sel, $values[$i]);
				}
			break;
		case 'as_array':
				foreach ($values as $tkey => $tval){
					$sel = (!strcasecmp($tkey, $aktiv))?' selected="selected"':'';
					$result .= sprintf("<option value=\"%s\"%s>%s</option>\n",$tkey,$sel, $tval);
				}
			break;
		case 'as2_array': // KEY = sichtbar Value = value
				foreach ($values as $tkey => $tval){
					$sel = (!strcasecmp($tval, $aktiv))?' selected="selected"':'';
					$result .= sprintf("<option value=\"%s\"%s>%s</option>\n",$tval,$sel, $tkey);
				}
			break;
		case 'k_v_array':
				for($i=0;$i<sizeof($values);$i++){
					$sel = (!strcasecmp($values[$i][$valname], $aktiv))?' selected="selected"':'';
					$tmp = ($encrypt)? $this->encrypt($values[$i][$valname]) : $values[$i][$valname];
					$result .= sprintf("<option value=\"%s\"%s>%s</option>\n",$tmp,$sel, $values[$i][$keyname]);
				}
			break;
		case 'k_v_array_m':
				if (!is_array($aktiv)) $aktiv = array();
				for($i=0;$i<sizeof($values);$i++){
					$sel = (in_array($values[$i][$valname], $aktiv))?' selected="selected"':'';
					$tmp = ($encrypt)? $this->encrypt($values[$i][$valname]) : $values[$i][$valname];
					$result .= sprintf("<option value=\"%s\"%s>%s</option>\n",$tmp,$sel, $values[$i][$keyname]);
				}
			break;
		case 'n_array_m':
				if (!is_array($aktiv)) $aktiv = array();

				for($i=0;$i<sizeof($values);$i++){
					$sel = (in_array($values[$i], $aktiv))?' selected="selected"':'';
					$result .= sprintf("<option value=\"%s\"%s>%s</option>\n",$values[$i],$sel, $values[$i]);
				}
			break;
		}
		return $result;
	}

	/**
	 * Fhrt einen Dateidownload Header aus<br />
     * @param int id aktuellen Mitglieds
     * @param int id des Betroffenen
	 * @access public
	 * @return string
	 */
	public function my_download($pfad_zur_datei)
	{
//		header('HTTP/1.1 200 OK');
//		header('Status: 200 OK');
//		header('Accept-Ranges: bytes');
		header('Content-Transfer-Encoding: Binary');
		header('Content-Type: application/force-download');
//		header('Content-Type: application/pdf');
		header(sprintf('Content-Disposition: inline; filename=%s', basename($pfad_zur_datei)));
//		header('Content-Disposition: attachment; filename=out.pdf');		
		
		readfile($pfad_zur_datei);	
		exit;
    }
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tdo_doptin_download/res/class/class.tx_tdodooptindownload_helper.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/tdo_doptin_download/res/class/class.tx_tdodooptindownload_helper.php']);
}

?>